

-- UUAGC 0.9.38.2 (LambdaExpr.ag)
module LambdaExpr where

{-# LINE 8 "LambdaExpr.ag" #-}

import RulerExpr
import UU.Scanner.Position
import Data.Set(Set)
import qualified Data.Set as Set
{-# LINE 13 "../derived/LambdaExpr.hs" #-}

{-# LINE 97 "LambdaExpr.ag" #-}

resNm :: Ident
resNm = ident "__res"

argNm :: Ident
argNm = ident "__arg"

altNm :: Ident
altNm = ident "__alt"

scrutNm :: Ident
scrutNm = ident "__scrut"

thisNm :: Ident
thisNm = ident "__this"
{-# LINE 31 "../derived/LambdaExpr.hs" #-}

{-# LINE 164 "LambdaExpr.ag" #-}

combineAlts :: Pos -> [Expr] -> Expr
combineAlts _ [expr] = expr
combineAlts pos exprs
  = Expr_Seq [ Stmt_Inst pos ( Expr_Derivation pos (Order_Relative [visitIdentMain]) [Param_Output visitIdentMain [resNm]] thisNm Level_Skip
                                 (zipWith (\n e -> Alt_Alt (Ident ("__guard" ++ show n) pos) []
                                                     [Stmt_Equiv pos (Expr_Field thisNm resNm) e]) [1..] exprs)
                             ) fld
             , Stmt_Establish pos fld Nothing
             ]
             (Expr_Field fld resNm)
  where
    fld = Ident "__guard" pos
{-# LINE 47 "../derived/LambdaExpr.hs" #-}

{-# LINE 191 "LambdaExpr.ag" #-}

mkFreshStmts :: Pos -> Set Ident -> Stmts
mkFreshStmts pos ids
  | Set.null ids = []
  | otherwise    = [ Stmt_Fresh pos (Set.toList ids) ]
{-# LINE 55 "../derived/LambdaExpr.hs" #-}

{-# LINE 274 "LambdaExpr.ag" #-}

mkStmtLet :: Bool -> Pos -> T_Pat -> Expr -> Stmts
mkStmtLet b p pat e = sem_StmtLet_Let p pat e b
{-# LINE 61 "../derived/LambdaExpr.hs" #-}
-- Bodies ------------------------------------------------------
type Bodies  = [Body ]
-- cata
sem_Bodies :: Bodies  ->
              T_Bodies 
sem_Bodies list  =
    (Prelude.foldr sem_Bodies_Cons sem_Bodies_Nil (Prelude.map sem_Body list) )
-- semantic domain
type T_Bodies  = ( ([Expr]))
sem_Bodies_Cons :: T_Body  ->
                   T_Bodies  ->
                   T_Bodies 
sem_Bodies_Cons hd_ tl_  =
    (let _lhsOexprs :: ([Expr])
         _hdIexprs :: ([Expr])
         _tlIexprs :: ([Expr])
         _lhsOexprs =
             ({-# LINE 179 "LambdaExpr.ag" #-}
              _hdIexprs ++ _tlIexprs
              {-# LINE 81 "LambdaExpr.hs" #-}
              )
         ( _hdIexprs) =
             hd_ 
         ( _tlIexprs) =
             tl_ 
     in  ( _lhsOexprs))
sem_Bodies_Nil :: T_Bodies 
sem_Bodies_Nil  =
    (let _lhsOexprs :: ([Expr])
         _lhsOexprs =
             ({-# LINE 179 "LambdaExpr.ag" #-}
              []
              {-# LINE 94 "LambdaExpr.hs" #-}
              )
     in  ( _lhsOexprs))
-- Body --------------------------------------------------------
data Body  = Body_Guarded !(Pos) !(Expr) !(Expr) 
           | Body_Unguarded !(Pos) !(Expr) 
           deriving ( Show)
-- cata
sem_Body :: Body  ->
            T_Body 
sem_Body (Body_Guarded _pos _guard _body )  =
    (sem_Body_Guarded _pos _guard _body )
sem_Body (Body_Unguarded _pos _body )  =
    (sem_Body_Unguarded _pos _body )
-- semantic domain
type T_Body  = ( ([Expr]))
sem_Body_Guarded :: Pos ->
                    Expr ->
                    Expr ->
                    T_Body 
sem_Body_Guarded pos_ guard_ body_  =
    (let _lhsOexprs :: ([Expr])
         _lhsOexprs =
             ({-# LINE 184 "LambdaExpr.ag" #-}
              [Expr_Seq [ Stmt_Equiv pos_ guard_ (Expr_Var Mode_Ref (Ident "true" pos_)) ] body_]
              {-# LINE 119 "LambdaExpr.hs" #-}
              )
     in  ( _lhsOexprs))
sem_Body_Unguarded :: Pos ->
                      Expr ->
                      T_Body 
sem_Body_Unguarded pos_ body_  =
    (let _lhsOexprs :: ([Expr])
         _lhsOexprs =
             ({-# LINE 182 "LambdaExpr.ag" #-}
              [body_]
              {-# LINE 130 "LambdaExpr.hs" #-}
              )
     in  ( _lhsOexprs))
-- Case --------------------------------------------------------
data Case  = Case_Case !(PatTop ) !(Bodies ) 
           deriving ( Show)
-- cata
sem_Case :: Case  ->
            T_Case 
sem_Case (Case_Case _pat _bodies )  =
    (sem_Case_Case (sem_PatTop _pat ) (sem_Bodies _bodies ) )
-- semantic domain
type T_Case  = Int ->
               ( Alts,Int)
sem_Case_Case :: T_PatTop  ->
                 T_Bodies  ->
                 T_Case 
sem_Case_Case pat_ bodies_  =
    (\ _lhsInr ->
         (let _lhsOalts :: Alts
              _lhsOnr :: Int
              _patIexpr :: Expr
              _patIfvs :: (Set Ident)
              _patIisSimple :: Bool
              _patIpos :: Pos
              _bodiesIexprs :: ([Expr])
              _pos =
                  ({-# LINE 158 "LambdaExpr.ag" #-}
                   _patIpos
                   {-# LINE 159 "LambdaExpr.hs" #-}
                   )
              _nm =
                  ({-# LINE 159 "LambdaExpr.ag" #-}
                   Ident ("__case" ++ show _lhsInr) _pos
                   {-# LINE 164 "LambdaExpr.hs" #-}
                   )
              _lhsOalts =
                  ({-# LINE 160 "LambdaExpr.ag" #-}
                   [ Alt_Alt _nm     [] (_matches     ++ [ Stmt_Equiv _pos     (Expr_Field thisNm resNm) (combineAlts _pos     _bodiesIexprs) ]) ]
                   {-# LINE 169 "LambdaExpr.hs" #-}
                   )
              _lhsOnr =
                  ({-# LINE 161 "LambdaExpr.ag" #-}
                   _lhsInr + 1
                   {-# LINE 174 "LambdaExpr.hs" #-}
                   )
              _matches =
                  ({-# LINE 162 "LambdaExpr.ag" #-}
                   mkFreshStmts _pos     _patIfvs ++ [ Stmt_Bind _pos     _patIexpr (Expr_Var Mode_Ref scrutNm) ]
                   {-# LINE 179 "LambdaExpr.hs" #-}
                   )
              ( _patIexpr,_patIfvs,_patIisSimple,_patIpos) =
                  pat_ 
              ( _bodiesIexprs) =
                  bodies_ 
          in  ( _lhsOalts,_lhsOnr)))
-- Cases -------------------------------------------------------
type Cases  = [Case ]
-- cata
sem_Cases :: Cases  ->
             T_Cases 
sem_Cases list  =
    (Prelude.foldr sem_Cases_Cons sem_Cases_Nil (Prelude.map sem_Case list) )
-- semantic domain
type T_Cases  = Int ->
                ( Alts,Int)
sem_Cases_Cons :: T_Case  ->
                  T_Cases  ->
                  T_Cases 
sem_Cases_Cons hd_ tl_  =
    (\ _lhsInr ->
         (let _lhsOalts :: Alts
              _lhsOnr :: Int
              _hdOnr :: Int
              _tlOnr :: Int
              _hdIalts :: Alts
              _hdInr :: Int
              _tlIalts :: Alts
              _tlInr :: Int
              _lhsOalts =
                  ({-# LINE 156 "LambdaExpr.ag" #-}
                   _hdIalts ++ _tlIalts
                   {-# LINE 212 "LambdaExpr.hs" #-}
                   )
              _lhsOnr =
                  ({-# LINE 156 "LambdaExpr.ag" #-}
                   _tlInr
                   {-# LINE 217 "LambdaExpr.hs" #-}
                   )
              _hdOnr =
                  ({-# LINE 156 "LambdaExpr.ag" #-}
                   _lhsInr
                   {-# LINE 222 "LambdaExpr.hs" #-}
                   )
              _tlOnr =
                  ({-# LINE 156 "LambdaExpr.ag" #-}
                   _hdInr
                   {-# LINE 227 "LambdaExpr.hs" #-}
                   )
              ( _hdIalts,_hdInr) =
                  hd_ _hdOnr 
              ( _tlIalts,_tlInr) =
                  tl_ _tlOnr 
          in  ( _lhsOalts,_lhsOnr)))
sem_Cases_Nil :: T_Cases 
sem_Cases_Nil  =
    (\ _lhsInr ->
         (let _lhsOalts :: Alts
              _lhsOnr :: Int
              _lhsOalts =
                  ({-# LINE 156 "LambdaExpr.ag" #-}
                   []
                   {-# LINE 242 "LambdaExpr.hs" #-}
                   )
              _lhsOnr =
                  ({-# LINE 156 "LambdaExpr.ag" #-}
                   _lhsInr
                   {-# LINE 247 "LambdaExpr.hs" #-}
                   )
          in  ( _lhsOalts,_lhsOnr)))
-- Decl --------------------------------------------------------
data Decl  = Decl_Decl !(PatTop ) !(Expr) 
           deriving ( Show)
-- cata
sem_Decl :: Decl  ->
            T_Decl 
sem_Decl (Decl_Decl _pat _body )  =
    (sem_Decl_Decl (sem_PatTop _pat ) _body )
-- semantic domain
type T_Decl  = Pos ->
               ( (Set Ident),Stmts)
sem_Decl_Decl :: T_PatTop  ->
                 Expr ->
                 T_Decl 
sem_Decl_Decl pat_ body_  =
    (\ _lhsIpos ->
         (let _lhsOstmts :: Stmts
              _lhsOfvs :: (Set Ident)
              _patIexpr :: Expr
              _patIfvs :: (Set Ident)
              _patIisSimple :: Bool
              _patIpos :: Pos
              _bindOp =
                  ({-# LINE 188 "LambdaExpr.ag" #-}
                   if _patIisSimple then Stmt_Equiv else Stmt_Bind
                   {-# LINE 275 "LambdaExpr.hs" #-}
                   )
              _lhsOstmts =
                  ({-# LINE 189 "LambdaExpr.ag" #-}
                   [ _bindOp     _lhsIpos _patIexpr body_ ]
                   {-# LINE 280 "LambdaExpr.hs" #-}
                   )
              _lhsOfvs =
                  ({-# LINE 260 "LambdaExpr.ag" #-}
                   _patIfvs
                   {-# LINE 285 "LambdaExpr.hs" #-}
                   )
              ( _patIexpr,_patIfvs,_patIisSimple,_patIpos) =
                  pat_ 
          in  ( _lhsOfvs,_lhsOstmts)))
-- Decls -------------------------------------------------------
type Decls  = [Decl ]
-- cata
sem_Decls :: Decls  ->
             T_Decls 
sem_Decls list  =
    (Prelude.foldr sem_Decls_Cons sem_Decls_Nil (Prelude.map sem_Decl list) )
-- semantic domain
type T_Decls  = Pos ->
                ( (Set Ident),Stmts)
sem_Decls_Cons :: T_Decl  ->
                  T_Decls  ->
                  T_Decls 
sem_Decls_Cons hd_ tl_  =
    (\ _lhsIpos ->
         (let _lhsOfvs :: (Set Ident)
              _lhsOstmts :: Stmts
              _hdOpos :: Pos
              _tlOpos :: Pos
              _hdIfvs :: (Set Ident)
              _hdIstmts :: Stmts
              _tlIfvs :: (Set Ident)
              _tlIstmts :: Stmts
              _lhsOfvs =
                  ({-# LINE 260 "LambdaExpr.ag" #-}
                   _hdIfvs `Set.union` _tlIfvs
                   {-# LINE 316 "LambdaExpr.hs" #-}
                   )
              _lhsOstmts =
                  ({-# LINE 186 "LambdaExpr.ag" #-}
                   _hdIstmts ++ _tlIstmts
                   {-# LINE 321 "LambdaExpr.hs" #-}
                   )
              _hdOpos =
                  ({-# LINE 186 "LambdaExpr.ag" #-}
                   _lhsIpos
                   {-# LINE 326 "LambdaExpr.hs" #-}
                   )
              _tlOpos =
                  ({-# LINE 186 "LambdaExpr.ag" #-}
                   _lhsIpos
                   {-# LINE 331 "LambdaExpr.hs" #-}
                   )
              ( _hdIfvs,_hdIstmts) =
                  hd_ _hdOpos 
              ( _tlIfvs,_tlIstmts) =
                  tl_ _tlOpos 
          in  ( _lhsOfvs,_lhsOstmts)))
sem_Decls_Nil :: T_Decls 
sem_Decls_Nil  =
    (\ _lhsIpos ->
         (let _lhsOfvs :: (Set Ident)
              _lhsOstmts :: Stmts
              _lhsOfvs =
                  ({-# LINE 260 "LambdaExpr.ag" #-}
                   Set.empty
                   {-# LINE 346 "LambdaExpr.hs" #-}
                   )
              _lhsOstmts =
                  ({-# LINE 186 "LambdaExpr.ag" #-}
                   []
                   {-# LINE 351 "LambdaExpr.hs" #-}
                   )
          in  ( _lhsOfvs,_lhsOstmts)))
-- LamAGItf ----------------------------------------------------
data LamAGItf  = LamAGItf_AGItf !(Lambda ) 
               deriving ( Show)
-- cata
sem_LamAGItf :: LamAGItf  ->
                T_LamAGItf 
sem_LamAGItf (LamAGItf_AGItf _body )  =
    (sem_LamAGItf_AGItf (sem_Lambda _body ) )
-- semantic domain
type T_LamAGItf  = ( Expr)
sem_LamAGItf_AGItf :: T_Lambda  ->
                      T_LamAGItf 
sem_LamAGItf_AGItf body_  =
    (let _lhsOexpr :: Expr
         _bodyIexpr :: Expr
         _lhsOexpr =
             ({-# LINE 95 "LambdaExpr.ag" #-}
              _bodyIexpr
              {-# LINE 372 "LambdaExpr.hs" #-}
              )
         ( _bodyIexpr) =
             body_ 
     in  ( _lhsOexpr))
-- Lambda ------------------------------------------------------
data Lambda  = Lambda_Abstract !(Pos) !(Ident) !(([Ident])) !(Expr) 
             | Lambda_App !(Expr) !(Expr) 
             | Lambda_Case !(Pos) !(Expr) !(Cases ) 
             | Lambda_Hide !(Pos) !(Expr) 
             | Lambda_Lam !(Pos) !(Pats ) !(Expr) 
             | Lambda_Let !(Pos) !(Decls ) !(Expr) 
             deriving ( Show)
-- cata
sem_Lambda :: Lambda  ->
              T_Lambda 
sem_Lambda (Lambda_Abstract _pos _nm _inputs _body )  =
    (sem_Lambda_Abstract _pos _nm _inputs _body )
sem_Lambda (Lambda_App _fun _arg )  =
    (sem_Lambda_App _fun _arg )
sem_Lambda (Lambda_Case _pos _scrut _cases )  =
    (sem_Lambda_Case _pos _scrut (sem_Cases _cases ) )
sem_Lambda (Lambda_Hide _pos _body )  =
    (sem_Lambda_Hide _pos _body )
sem_Lambda (Lambda_Lam _pos _params _body )  =
    (sem_Lambda_Lam _pos (sem_Pats _params ) _body )
sem_Lambda (Lambda_Let _pos _decls _body )  =
    (sem_Lambda_Let _pos (sem_Decls _decls ) _body )
-- semantic domain
type T_Lambda  = ( Expr)
sem_Lambda_Abstract :: Pos ->
                       Ident ->
                       ([Ident]) ->
                       Expr ->
                       T_Lambda 
sem_Lambda_Abstract pos_ nm_ inputs_ body_  =
    (let _lhsOexpr :: Expr
         _fld =
             ({-# LINE 142 "LambdaExpr.ag" #-}
              Ident "__abstract" pos_
              {-# LINE 412 "LambdaExpr.hs" #-}
              )
         _deriv =
             ({-# LINE 143 "LambdaExpr.ag" #-}
              Expr_Derivation pos_ (Order_Relative [visitIdentMain]) [ Param_Input visitIdentMain inputs_, Param_Output visitIdentMain [resNm] ] thisNm (Level_Abstract nm_)
                [ Alt_Alt altNm [] [ Stmt_Equiv pos_ (Expr_Field thisNm resNm) body_ ] ]
              {-# LINE 418 "LambdaExpr.hs" #-}
              )
         _lhsOexpr =
             ({-# LINE 145 "LambdaExpr.ag" #-}
              Expr_Seq (  [ Stmt_Inst pos_ _deriv     _fld     ]
                       ++ map (\inp -> Stmt_Equiv pos_ (Expr_Field _fld     inp) (Expr_Var Mode_Ref inp)) inputs_
                       ++ [ Stmt_Establish pos_ _fld     Nothing ]
                       )
                       (Expr_Field _fld     resNm)
              {-# LINE 427 "LambdaExpr.hs" #-}
              )
     in  ( _lhsOexpr))
sem_Lambda_App :: Expr ->
                  Expr ->
                  T_Lambda 
sem_Lambda_App fun_ arg_  =
    (let _lhsOexpr :: Expr
         _pos =
             ({-# LINE 117 "LambdaExpr.ag" #-}
              exprPos fun_
              {-# LINE 438 "LambdaExpr.hs" #-}
              )
         _fld =
             ({-# LINE 118 "LambdaExpr.ag" #-}
              Ident "__app" _pos
              {-# LINE 443 "LambdaExpr.hs" #-}
              )
         _lhsOexpr =
             ({-# LINE 119 "LambdaExpr.ag" #-}
              Expr_Seq [ Stmt_Inst _pos     fun_ _fld
                       , Stmt_Equiv _pos     (Expr_Field _fld     argNm) arg_
                       , Stmt_Establish _pos     _fld     Nothing
                       ]
                       (Expr_Field _fld     resNm)
              {-# LINE 452 "LambdaExpr.hs" #-}
              )
     in  ( _lhsOexpr))
sem_Lambda_Case :: Pos ->
                   Expr ->
                   T_Cases  ->
                   T_Lambda 
sem_Lambda_Case pos_ scrut_ cases_  =
    (let _lhsOexpr :: Expr
         _casesOnr :: Int
         _casesIalts :: Alts
         _casesInr :: Int
         _fld =
             ({-# LINE 132 "LambdaExpr.ag" #-}
              Ident "__invoke" pos_
              {-# LINE 467 "LambdaExpr.hs" #-}
              )
         _deriv =
             ({-# LINE 133 "LambdaExpr.ag" #-}
              Expr_Derivation pos_ (Order_Relative [visitIdentMain]) [ Param_Output visitIdentMain [resNm] ] thisNm Level_Skip _casesIalts
              {-# LINE 472 "LambdaExpr.hs" #-}
              )
         _lhsOexpr =
             ({-# LINE 134 "LambdaExpr.ag" #-}
              Expr_Seq [ Stmt_Fresh pos_ [scrutNm]
                       , Stmt_Equiv pos_ (Expr_Var Mode_Def scrutNm) scrut_
                       , Stmt_Inst pos_ _deriv     _fld
                       , Stmt_Establish pos_ _fld     Nothing
                       ]
                       (Expr_Field _fld     resNm)
              {-# LINE 482 "LambdaExpr.hs" #-}
              )
         _casesOnr =
             ({-# LINE 140 "LambdaExpr.ag" #-}
              1
              {-# LINE 487 "LambdaExpr.hs" #-}
              )
         ( _casesIalts,_casesInr) =
             cases_ _casesOnr 
     in  ( _lhsOexpr))
sem_Lambda_Hide :: Pos ->
                   Expr ->
                   T_Lambda 
sem_Lambda_Hide pos_ body_  =
    (let _lhsOexpr :: Expr
         _fld =
             ({-# LINE 151 "LambdaExpr.ag" #-}
              Ident "__hide" pos_
              {-# LINE 500 "LambdaExpr.hs" #-}
              )
         _deriv =
             ({-# LINE 152 "LambdaExpr.ag" #-}
              Expr_Derivation pos_ (Order_Relative [visitIdentMain]) [ Param_Output visitIdentMain [resNm] ] thisNm Level_Hide
                [ Alt_Alt altNm [] [ Stmt_Equiv pos_ (Expr_Field thisNm resNm) body_ ] ]
              {-# LINE 506 "LambdaExpr.hs" #-}
              )
         _lhsOexpr =
             ({-# LINE 154 "LambdaExpr.ag" #-}
              Expr_Seq [ Stmt_Inst pos_ _deriv     _fld    , Stmt_Establish pos_ _fld     Nothing ] (Expr_Field _fld     resNm)
              {-# LINE 511 "LambdaExpr.hs" #-}
              )
     in  ( _lhsOexpr))
sem_Lambda_Lam :: Pos ->
                  T_Pats  ->
                  Expr ->
                  T_Lambda 
sem_Lambda_Lam pos_ params_ body_  =
    (let _lhsOexpr :: Expr
         _paramsIbindings :: ([(Expr, Set Ident)])
         _lhsOexpr =
             ({-# LINE 124 "LambdaExpr.ag" #-}
              let level (param,fvsParam) body =
                    Expr_Derivation pos_ (Order_Relative [visitIdentMain])
                      [ Param_Input visitIdentMain [argNm], Param_Output visitIdentMain [resNm] ]
                      thisNm Level_Skip
                      [ Alt_Alt altNm [] [ Stmt_Equiv pos_ (Expr_Field thisNm resNm) (Expr_Seq (mkFreshStmts pos_ fvsParam ++ [ Stmt_Bind pos_ param (Expr_Field thisNm argNm) ]) body) ] ]
              in foldr level body_ _paramsIbindings
              {-# LINE 529 "LambdaExpr.hs" #-}
              )
         ( _paramsIbindings) =
             params_ 
     in  ( _lhsOexpr))
sem_Lambda_Let :: Pos ->
                  T_Decls  ->
                  Expr ->
                  T_Lambda 
sem_Lambda_Let pos_ decls_ body_  =
    (let _declsOpos :: Pos
         _lhsOexpr :: Expr
         _declsIfvs :: (Set Ident)
         _declsIstmts :: Stmts
         _declsOpos =
             ({-# LINE 130 "LambdaExpr.ag" #-}
              pos_
              {-# LINE 546 "LambdaExpr.hs" #-}
              )
         _lhsOexpr =
             ({-# LINE 131 "LambdaExpr.ag" #-}
              Expr_Seq ( mkFreshStmts pos_ _declsIfvs ++ _declsIstmts) body_
              {-# LINE 551 "LambdaExpr.hs" #-}
              )
         ( _declsIfvs,_declsIstmts) =
             decls_ _declsOpos 
     in  ( _lhsOexpr))
-- Pat ---------------------------------------------------------
data Pat  = Pat_App !(Pat ) !(Pat ) 
          | Pat_Escape !(Pos) !(Expr) 
          | Pat_Prim !(Pos) !(PrimVal) 
          | Pat_Underscore !(Pos) 
          | Pat_Var !(Ident) 
          deriving ( Show)
-- cata
sem_Pat :: Pat  ->
           T_Pat 
sem_Pat (Pat_App _fun _arg )  =
    (sem_Pat_App (sem_Pat _fun ) (sem_Pat _arg ) )
sem_Pat (Pat_Escape _pos _expr )  =
    (sem_Pat_Escape _pos _expr )
sem_Pat (Pat_Prim _pos _val )  =
    (sem_Pat_Prim _pos _val )
sem_Pat (Pat_Underscore _pos )  =
    (sem_Pat_Underscore _pos )
sem_Pat (Pat_Var _nm )  =
    (sem_Pat_Var _nm )
-- semantic domain
type T_Pat  = Bool ->
              ( Expr,(Set Ident),Bool,Pos)
sem_Pat_App :: T_Pat  ->
               T_Pat  ->
               T_Pat 
sem_Pat_App fun_ arg_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOisSimple :: Bool
              _lhsOpos :: Pos
              _funOisLhsOfApp :: Bool
              _argOisLhsOfApp :: Bool
              _lhsOfvs :: (Set Ident)
              _funIexpr :: Expr
              _funIfvs :: (Set Ident)
              _funIisSimple :: Bool
              _funIpos :: Pos
              _argIexpr :: Expr
              _argIfvs :: (Set Ident)
              _argIisSimple :: Bool
              _argIpos :: Pos
              _pos =
                  ({-# LINE 205 "LambdaExpr.ag" #-}
                   _funIpos
                   {-# LINE 601 "LambdaExpr.hs" #-}
                   )
              _fld =
                  ({-# LINE 206 "LambdaExpr.ag" #-}
                   Ident "__pat" _pos
                   {-# LINE 606 "LambdaExpr.hs" #-}
                   )
              _lhsOexpr =
                  ({-# LINE 207 "LambdaExpr.ag" #-}
                   Expr_Seq [ Stmt_Inst _pos     _funIexpr _fld
                            , Stmt_Equiv _pos     (Expr_Field _fld     argNm) _argIexpr
                            , Stmt_Establish _pos     _fld     Nothing
                            ]
                            (Expr_Field _fld     resNm)
                   {-# LINE 615 "LambdaExpr.hs" #-}
                   )
              _lhsOisSimple =
                  ({-# LINE 225 "LambdaExpr.ag" #-}
                   False
                   {-# LINE 620 "LambdaExpr.hs" #-}
                   )
              _lhsOpos =
                  ({-# LINE 239 "LambdaExpr.ag" #-}
                   _funIpos
                   {-# LINE 625 "LambdaExpr.hs" #-}
                   )
              _funOisLhsOfApp =
                  ({-# LINE 255 "LambdaExpr.ag" #-}
                   True
                   {-# LINE 630 "LambdaExpr.hs" #-}
                   )
              _argOisLhsOfApp =
                  ({-# LINE 256 "LambdaExpr.ag" #-}
                   False
                   {-# LINE 635 "LambdaExpr.hs" #-}
                   )
              _lhsOfvs =
                  ({-# LINE 260 "LambdaExpr.ag" #-}
                   _funIfvs `Set.union` _argIfvs
                   {-# LINE 640 "LambdaExpr.hs" #-}
                   )
              ( _funIexpr,_funIfvs,_funIisSimple,_funIpos) =
                  fun_ _funOisLhsOfApp 
              ( _argIexpr,_argIfvs,_argIisSimple,_argIpos) =
                  arg_ _argOisLhsOfApp 
          in  ( _lhsOexpr,_lhsOfvs,_lhsOisSimple,_lhsOpos)))
sem_Pat_Escape :: Pos ->
                  Expr ->
                  T_Pat 
sem_Pat_Escape pos_ expr_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOisSimple :: Bool
              _lhsOpos :: Pos
              _lhsOfvs :: (Set Ident)
              _lhsOexpr =
                  ({-# LINE 220 "LambdaExpr.ag" #-}
                   expr_
                   {-# LINE 659 "LambdaExpr.hs" #-}
                   )
              _lhsOisSimple =
                  ({-# LINE 226 "LambdaExpr.ag" #-}
                   False
                   {-# LINE 664 "LambdaExpr.hs" #-}
                   )
              _lhsOpos =
                  ({-# LINE 243 "LambdaExpr.ag" #-}
                   pos_
                   {-# LINE 669 "LambdaExpr.hs" #-}
                   )
              _lhsOfvs =
                  ({-# LINE 260 "LambdaExpr.ag" #-}
                   Set.empty
                   {-# LINE 674 "LambdaExpr.hs" #-}
                   )
          in  ( _lhsOexpr,_lhsOfvs,_lhsOisSimple,_lhsOpos)))
sem_Pat_Prim :: Pos ->
                PrimVal ->
                T_Pat 
sem_Pat_Prim pos_ val_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOisSimple :: Bool
              _lhsOpos :: Pos
              _lhsOfvs :: (Set Ident)
              _lhsOexpr =
                  ({-# LINE 216 "LambdaExpr.ag" #-}
                   Expr_Prim pos_ val_
                   {-# LINE 689 "LambdaExpr.hs" #-}
                   )
              _lhsOisSimple =
                  ({-# LINE 217 "LambdaExpr.ag" #-}
                   True
                   {-# LINE 694 "LambdaExpr.hs" #-}
                   )
              _lhsOpos =
                  ({-# LINE 241 "LambdaExpr.ag" #-}
                   pos_
                   {-# LINE 699 "LambdaExpr.hs" #-}
                   )
              _lhsOfvs =
                  ({-# LINE 260 "LambdaExpr.ag" #-}
                   Set.empty
                   {-# LINE 704 "LambdaExpr.hs" #-}
                   )
          in  ( _lhsOexpr,_lhsOfvs,_lhsOisSimple,_lhsOpos)))
sem_Pat_Underscore :: Pos ->
                      T_Pat 
sem_Pat_Underscore pos_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOpos :: Pos
              _lhsOfvs :: (Set Ident)
              _lhsOisSimple :: Bool
              _ident =
                  ({-# LINE 218 "LambdaExpr.ag" #-}
                   Ident "__fresh" pos_
                   {-# LINE 718 "LambdaExpr.hs" #-}
                   )
              _lhsOexpr =
                  ({-# LINE 219 "LambdaExpr.ag" #-}
                   Expr_Seq [Stmt_Fresh pos_ [_ident    ]] (Expr_Var Mode_Ref _ident    )
                   {-# LINE 723 "LambdaExpr.hs" #-}
                   )
              _lhsOpos =
                  ({-# LINE 242 "LambdaExpr.ag" #-}
                   pos_
                   {-# LINE 728 "LambdaExpr.hs" #-}
                   )
              _lhsOfvs =
                  ({-# LINE 260 "LambdaExpr.ag" #-}
                   Set.empty
                   {-# LINE 733 "LambdaExpr.hs" #-}
                   )
              _lhsOisSimple =
                  ({-# LINE 223 "LambdaExpr.ag" #-}
                   True
                   {-# LINE 738 "LambdaExpr.hs" #-}
                   )
          in  ( _lhsOexpr,_lhsOfvs,_lhsOisSimple,_lhsOpos)))
sem_Pat_Var :: Ident ->
               T_Pat 
sem_Pat_Var nm_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOpos :: Pos
              _lhsOfvs :: (Set Ident)
              _lhsOisSimple :: Bool
              _mode =
                  ({-# LINE 212 "LambdaExpr.ag" #-}
                   if _lhsIisLhsOfApp
                   then Mode_Ref
                   else Mode_Def
                   {-# LINE 754 "LambdaExpr.hs" #-}
                   )
              _lhsOexpr =
                  ({-# LINE 215 "LambdaExpr.ag" #-}
                   Expr_Var _mode     nm_
                   {-# LINE 759 "LambdaExpr.hs" #-}
                   )
              _lhsOpos =
                  ({-# LINE 240 "LambdaExpr.ag" #-}
                   identPos nm_
                   {-# LINE 764 "LambdaExpr.hs" #-}
                   )
              _lhsOfvs =
                  ({-# LINE 262 "LambdaExpr.ag" #-}
                   if _lhsIisLhsOfApp
                   then Set.empty
                   else Set.singleton nm_
                   {-# LINE 771 "LambdaExpr.hs" #-}
                   )
              _lhsOisSimple =
                  ({-# LINE 223 "LambdaExpr.ag" #-}
                   True
                   {-# LINE 776 "LambdaExpr.hs" #-}
                   )
          in  ( _lhsOexpr,_lhsOfvs,_lhsOisSimple,_lhsOpos)))
-- PatTop ------------------------------------------------------
data PatTop  = PatTop_Top !(Pat ) 
             deriving ( Show)
-- cata
sem_PatTop :: PatTop  ->
              T_PatTop 
sem_PatTop (PatTop_Top _pat )  =
    (sem_PatTop_Top (sem_Pat _pat ) )
-- semantic domain
type T_PatTop  = ( Expr,(Set Ident),Bool,Pos)
sem_PatTop_Top :: T_Pat  ->
                  T_PatTop 
sem_PatTop_Top pat_  =
    (let _patOisLhsOfApp :: Bool
         _lhsOfvs :: (Set Ident)
         _lhsOisSimple :: Bool
         _lhsOexpr :: Expr
         _lhsOpos :: Pos
         _patIexpr :: Expr
         _patIfvs :: (Set Ident)
         _patIisSimple :: Bool
         _patIpos :: Pos
         _patOisLhsOfApp =
             ({-# LINE 258 "LambdaExpr.ag" #-}
              False
              {-# LINE 804 "LambdaExpr.hs" #-}
              )
         _lhsOfvs =
             ({-# LINE 260 "LambdaExpr.ag" #-}
              _patIfvs
              {-# LINE 809 "LambdaExpr.hs" #-}
              )
         _lhsOisSimple =
             ({-# LINE 223 "LambdaExpr.ag" #-}
              _patIisSimple
              {-# LINE 814 "LambdaExpr.hs" #-}
              )
         _lhsOexpr =
             ({-# LINE 203 "LambdaExpr.ag" #-}
              _patIexpr
              {-# LINE 819 "LambdaExpr.hs" #-}
              )
         _lhsOpos =
             ({-# LINE 237 "LambdaExpr.ag" #-}
              _patIpos
              {-# LINE 824 "LambdaExpr.hs" #-}
              )
         ( _patIexpr,_patIfvs,_patIisSimple,_patIpos) =
             pat_ _patOisLhsOfApp 
     in  ( _lhsOexpr,_lhsOfvs,_lhsOisSimple,_lhsOpos))
-- Pats --------------------------------------------------------
type Pats  = [PatTop ]
-- cata
sem_Pats :: Pats  ->
            T_Pats 
sem_Pats list  =
    (Prelude.foldr sem_Pats_Cons sem_Pats_Nil (Prelude.map sem_PatTop list) )
-- semantic domain
type T_Pats  = ( ([(Expr, Set Ident)]))
sem_Pats_Cons :: T_PatTop  ->
                 T_Pats  ->
                 T_Pats 
sem_Pats_Cons hd_ tl_  =
    (let _lhsObindings :: ([(Expr, Set Ident)])
         _hdIexpr :: Expr
         _hdIfvs :: (Set Ident)
         _hdIisSimple :: Bool
         _hdIpos :: Pos
         _tlIbindings :: ([(Expr, Set Ident)])
         _lhsObindings =
             ({-# LINE 230 "LambdaExpr.ag" #-}
              (_hdIexpr, _hdIfvs) : _tlIbindings
              {-# LINE 851 "LambdaExpr.hs" #-}
              )
         ( _hdIexpr,_hdIfvs,_hdIisSimple,_hdIpos) =
             hd_ 
         ( _tlIbindings) =
             tl_ 
     in  ( _lhsObindings))
sem_Pats_Nil :: T_Pats 
sem_Pats_Nil  =
    (let _lhsObindings :: ([(Expr, Set Ident)])
         _lhsObindings =
             ({-# LINE 231 "LambdaExpr.ag" #-}
              []
              {-# LINE 864 "LambdaExpr.hs" #-}
              )
     in  ( _lhsObindings))
-- StmtLet -----------------------------------------------------
data StmtLet  = StmtLet_Let !(Pos) !(Pat ) !(Expr) 
              deriving ( Show)
-- cata
sem_StmtLet :: StmtLet  ->
               T_StmtLet 
sem_StmtLet (StmtLet_Let _pos _pat _expr )  =
    (sem_StmtLet_Let _pos (sem_Pat _pat ) _expr )
-- semantic domain
type T_StmtLet  = Bool ->
                  ( Stmts)
sem_StmtLet_Let :: Pos ->
                   T_Pat  ->
                   Expr ->
                   T_StmtLet 
sem_StmtLet_Let pos_ pat_ expr_  =
    (\ _lhsIonDerivation ->
         (let _patOisLhsOfApp :: Bool
              _lhsOstmts :: Stmts
              _patIexpr :: Expr
              _patIfvs :: (Set Ident)
              _patIisSimple :: Bool
              _patIpos :: Pos
              _bindOp =
                  ({-# LINE 285 "LambdaExpr.ag" #-}
                   if _patIisSimple then Stmt_Equiv else Stmt_Bind
                   {-# LINE 893 "LambdaExpr.hs" #-}
                   )
              _patOisLhsOfApp =
                  ({-# LINE 286 "LambdaExpr.ag" #-}
                   False
                   {-# LINE 898 "LambdaExpr.hs" #-}
                   )
              _freshStmts =
                  ({-# LINE 287 "LambdaExpr.ag" #-}
                   if _lhsIonDerivation
                   then []
                   else [ Stmt_Fresh pos_ (Set.toList _patIfvs) ]
                   {-# LINE 905 "LambdaExpr.hs" #-}
                   )
              _lhsOstmts =
                  ({-# LINE 290 "LambdaExpr.ag" #-}
                   _freshStmts     ++ [ _bindOp     pos_ _patIexpr expr_ ]
                   {-# LINE 910 "LambdaExpr.hs" #-}
                   )
              ( _patIexpr,_patIfvs,_patIisSimple,_patIpos) =
                  pat_ _patOisLhsOfApp 
          in  ( _lhsOstmts)))