

-- UUAGC 0.9.38.2 (RulesExpr.ag)
module RulesExpr where

{-# LINE 8 "RulesExpr.ag" #-}

import RulerExpr
import UU.Scanner.Position
import LambdaExpr
{-# LINE 12 "../derived/RulesExpr.hs" #-}
-- Augment -----------------------------------------------------
data Augment  = Augment_Input !(Pos) !(String) !(Expr) 
              | Augment_Output !(Pos) !(String) !(PatOutput ) 
-- cata
sem_Augment :: Augment  ->
               T_Augment 
sem_Augment (Augment_Input _pos _nm _expr )  =
    (sem_Augment_Input _pos _nm _expr )
sem_Augment (Augment_Output _pos _nm _body )  =
    (sem_Augment_Output _pos _nm (sem_PatOutput _body ) )
-- semantic domain
type T_Augment  = Ident ->
                  Pos ->
                  ( Stmts)
sem_Augment_Input :: Pos ->
                     String ->
                     Expr ->
                     T_Augment 
sem_Augment_Input pos_ nm_ expr_  =
    (\ _lhsIderiv
       _lhsIpos ->
         (let _lhsOstmts :: Stmts
              _lhsOstmts =
                  ({-# LINE 119 "RulesExpr.ag" #-}
                   [ Stmt_Equiv _lhsIpos (Expr_Field _lhsIderiv (Ident nm_ _lhsIpos)) expr_ ]
                   {-# LINE 38 "RulesExpr.hs" #-}
                   )
          in  ( _lhsOstmts)))
sem_Augment_Output :: Pos ->
                      String ->
                      T_PatOutput  ->
                      T_Augment 
sem_Augment_Output pos_ nm_ body_  =
    (\ _lhsIderiv
       _lhsIpos ->
         (let _bodyOisLhsOfApp :: Bool
              _lhsOstmts :: Stmts
              _bodyIexpr :: Expr
              _bodyOisLhsOfApp =
                  ({-# LINE 61 "RulesExpr.ag" #-}
                   False
                   {-# LINE 54 "RulesExpr.hs" #-}
                   )
              _lhsOstmts =
                  ({-# LINE 120 "RulesExpr.ag" #-}
                   [ Stmt_Bind _lhsIpos _bodyIexpr (Expr_Field _lhsIderiv (Ident nm_ _lhsIpos)) ]
                   {-# LINE 59 "RulesExpr.hs" #-}
                   )
              ( _bodyIexpr) =
                  body_ _bodyOisLhsOfApp 
          in  ( _lhsOstmts)))
-- Augments ----------------------------------------------------
type Augments  = [Augment ]
-- cata
sem_Augments :: Augments  ->
                T_Augments 
sem_Augments list  =
    (Prelude.foldr sem_Augments_Cons sem_Augments_Nil (Prelude.map sem_Augment list) )
-- semantic domain
type T_Augments  = Ident ->
                   Pos ->
                   ( Stmts)
sem_Augments_Cons :: T_Augment  ->
                     T_Augments  ->
                     T_Augments 
sem_Augments_Cons hd_ tl_  =
    (\ _lhsIderiv
       _lhsIpos ->
         (let _lhsOstmts :: Stmts
              _hdOderiv :: Ident
              _hdOpos :: Pos
              _tlOderiv :: Ident
              _tlOpos :: Pos
              _hdIstmts :: Stmts
              _tlIstmts :: Stmts
              _lhsOstmts =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _hdIstmts ++ _tlIstmts
                   {-# LINE 91 "RulesExpr.hs" #-}
                   )
              _hdOderiv =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _lhsIderiv
                   {-# LINE 96 "RulesExpr.hs" #-}
                   )
              _hdOpos =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _lhsIpos
                   {-# LINE 101 "RulesExpr.hs" #-}
                   )
              _tlOderiv =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _lhsIderiv
                   {-# LINE 106 "RulesExpr.hs" #-}
                   )
              _tlOpos =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _lhsIpos
                   {-# LINE 111 "RulesExpr.hs" #-}
                   )
              ( _hdIstmts) =
                  hd_ _hdOderiv _hdOpos 
              ( _tlIstmts) =
                  tl_ _tlOderiv _tlOpos 
          in  ( _lhsOstmts)))
sem_Augments_Nil :: T_Augments 
sem_Augments_Nil  =
    (\ _lhsIderiv
       _lhsIpos ->
         (let _lhsOstmts :: Stmts
              _lhsOstmts =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   []
                   {-# LINE 126 "RulesExpr.hs" #-}
                   )
          in  ( _lhsOstmts)))
-- Augmentss ---------------------------------------------------
type Augmentss  = [Augments ]
-- cata
sem_Augmentss :: Augmentss  ->
                 T_Augmentss 
sem_Augmentss list  =
    (Prelude.foldr sem_Augmentss_Cons sem_Augmentss_Nil (Prelude.map sem_Augments list) )
-- semantic domain
type T_Augmentss  = Ident ->
                    Pos ->
                    ( Stmts)
sem_Augmentss_Cons :: T_Augments  ->
                      T_Augmentss  ->
                      T_Augmentss 
sem_Augmentss_Cons hd_ tl_  =
    (\ _lhsIderiv
       _lhsIpos ->
         (let _lhsOstmts :: Stmts
              _hdOderiv :: Ident
              _hdOpos :: Pos
              _tlOderiv :: Ident
              _tlOpos :: Pos
              _hdIstmts :: Stmts
              _tlIstmts :: Stmts
              _lhsOstmts =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _hdIstmts ++ _tlIstmts
                   {-# LINE 156 "RulesExpr.hs" #-}
                   )
              _hdOderiv =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _lhsIderiv
                   {-# LINE 161 "RulesExpr.hs" #-}
                   )
              _hdOpos =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _lhsIpos
                   {-# LINE 166 "RulesExpr.hs" #-}
                   )
              _tlOderiv =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _lhsIderiv
                   {-# LINE 171 "RulesExpr.hs" #-}
                   )
              _tlOpos =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   _lhsIpos
                   {-# LINE 176 "RulesExpr.hs" #-}
                   )
              ( _hdIstmts) =
                  hd_ _hdOderiv _hdOpos 
              ( _tlIstmts) =
                  tl_ _tlOderiv _tlOpos 
          in  ( _lhsOstmts)))
sem_Augmentss_Nil :: T_Augmentss 
sem_Augmentss_Nil  =
    (\ _lhsIderiv
       _lhsIpos ->
         (let _lhsOstmts :: Stmts
              _lhsOstmts =
                  ({-# LINE 99 "RulesExpr.ag" #-}
                   []
                   {-# LINE 191 "RulesExpr.hs" #-}
                   )
          in  ( _lhsOstmts)))
-- EqStmt ------------------------------------------------------
data EqStmt  = EqStmt_Augment !(Pos) !(Ident) !(Augments ) 
             | EqStmt_Conclusion !(Pos) !(Augmentss ) 
             | EqStmt_Establish !(Pos) !(Ident) !(Augments ) !((Maybe Ident)) 
-- cata
sem_EqStmt :: EqStmt  ->
              T_EqStmt 
sem_EqStmt (EqStmt_Augment _pos _deriv _body )  =
    (sem_EqStmt_Augment _pos _deriv (sem_Augments _body ) )
sem_EqStmt (EqStmt_Conclusion _pos _body )  =
    (sem_EqStmt_Conclusion _pos (sem_Augmentss _body ) )
sem_EqStmt (EqStmt_Establish _pos _source _body _mbAs )  =
    (sem_EqStmt_Establish _pos _source (sem_Augments _body ) _mbAs )
-- semantic domain
type T_EqStmt  = ( Stmts)
sem_EqStmt_Augment :: Pos ->
                      Ident ->
                      T_Augments  ->
                      T_EqStmt 
sem_EqStmt_Augment pos_ deriv_ body_  =
    (let _bodyOderiv :: Ident
         _bodyOpos :: Pos
         _lhsOstmts :: Stmts
         _bodyIstmts :: Stmts
         _bodyOderiv =
             ({-# LINE 103 "RulesExpr.ag" #-}
              deriv_
              {-# LINE 221 "RulesExpr.hs" #-}
              )
         _bodyOpos =
             ({-# LINE 104 "RulesExpr.ag" #-}
              pos_
              {-# LINE 226 "RulesExpr.hs" #-}
              )
         _lhsOstmts =
             ({-# LINE 98 "RulesExpr.ag" #-}
              _bodyIstmts
              {-# LINE 231 "RulesExpr.hs" #-}
              )
         ( _bodyIstmts) =
             body_ _bodyOderiv _bodyOpos 
     in  ( _lhsOstmts))
sem_EqStmt_Conclusion :: Pos ->
                         T_Augmentss  ->
                         T_EqStmt 
sem_EqStmt_Conclusion pos_ body_  =
    (let _bodyOderiv :: Ident
         _bodyOpos :: Pos
         _lhsOstmts :: Stmts
         _bodyIstmts :: Stmts
         _bodyOderiv =
             ({-# LINE 115 "RulesExpr.ag" #-}
              Ident "__this" pos_
              {-# LINE 247 "RulesExpr.hs" #-}
              )
         _bodyOpos =
             ({-# LINE 116 "RulesExpr.ag" #-}
              pos_
              {-# LINE 252 "RulesExpr.hs" #-}
              )
         _lhsOstmts =
             ({-# LINE 98 "RulesExpr.ag" #-}
              _bodyIstmts
              {-# LINE 257 "RulesExpr.hs" #-}
              )
         ( _bodyIstmts) =
             body_ _bodyOderiv _bodyOpos 
     in  ( _lhsOstmts))
sem_EqStmt_Establish :: Pos ->
                        Ident ->
                        T_Augments  ->
                        (Maybe Ident) ->
                        T_EqStmt 
sem_EqStmt_Establish pos_ source_ body_ mbAs_  =
    (let _bodyOderiv :: Ident
         _bodyOpos :: Pos
         _lhsOstmts :: Stmts
         _bodyIstmts :: Stmts
         _deriv =
             ({-# LINE 106 "RulesExpr.ag" #-}
              case mbAs_ of
                Just nm -> nm
                Nothing -> Ident (identName source_ ++ "-" ++ show (line pos_) ++ "d" ++ show (column pos_)) pos_
              {-# LINE 277 "RulesExpr.hs" #-}
              )
         _bodyOderiv =
             ({-# LINE 109 "RulesExpr.ag" #-}
              _deriv
              {-# LINE 282 "RulesExpr.hs" #-}
              )
         _bodyOpos =
             ({-# LINE 110 "RulesExpr.ag" #-}
              pos_
              {-# LINE 287 "RulesExpr.hs" #-}
              )
         _lhsOstmts =
             ({-# LINE 111 "RulesExpr.ag" #-}
              [ Stmt_Inst pos_ (Expr_Var Mode_Ref source_) _deriv     ]
              ++ _bodyIstmts
              ++ [ Stmt_Establish pos_ _deriv     Nothing ]
              {-# LINE 294 "RulesExpr.hs" #-}
              )
         ( _bodyIstmts) =
             body_ _bodyOderiv _bodyOpos 
     in  ( _lhsOstmts))
-- PatOutput ---------------------------------------------------
data PatOutput  = PatOutput_App !(PatOutput ) !(PatOutput ) 
                | PatOutput_Escape !(Pos) !(Expr) 
                | PatOutput_Field !(Ident) !(Ident) 
                | PatOutput_Prim !(Pos) !(PrimVal) 
                | PatOutput_Underscore !(Pos) 
                | PatOutput_Var !(Ident) 
-- cata
sem_PatOutput :: PatOutput  ->
                 T_PatOutput 
sem_PatOutput (PatOutput_App _fun _arg )  =
    (sem_PatOutput_App (sem_PatOutput _fun ) (sem_PatOutput _arg ) )
sem_PatOutput (PatOutput_Escape _pos _expr )  =
    (sem_PatOutput_Escape _pos _expr )
sem_PatOutput (PatOutput_Field _fld _nm )  =
    (sem_PatOutput_Field _fld _nm )
sem_PatOutput (PatOutput_Prim _pos _val )  =
    (sem_PatOutput_Prim _pos _val )
sem_PatOutput (PatOutput_Underscore _pos )  =
    (sem_PatOutput_Underscore _pos )
sem_PatOutput (PatOutput_Var _nm )  =
    (sem_PatOutput_Var _nm )
-- semantic domain
type T_PatOutput  = Bool ->
                    ( Expr)
sem_PatOutput_App :: T_PatOutput  ->
                     T_PatOutput  ->
                     T_PatOutput 
sem_PatOutput_App fun_ arg_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _funOisLhsOfApp :: Bool
              _argOisLhsOfApp :: Bool
              _funIexpr :: Expr
              _argIexpr :: Expr
              _lhsOexpr =
                  ({-# LINE 41 "RulesExpr.ag" #-}
                   sem_Lambda_App _funIexpr _argIexpr
                   {-# LINE 337 "RulesExpr.hs" #-}
                   )
              _funOisLhsOfApp =
                  ({-# LINE 64 "RulesExpr.ag" #-}
                   True
                   {-# LINE 342 "RulesExpr.hs" #-}
                   )
              _argOisLhsOfApp =
                  ({-# LINE 65 "RulesExpr.ag" #-}
                   False
                   {-# LINE 347 "RulesExpr.hs" #-}
                   )
              ( _funIexpr) =
                  fun_ _funOisLhsOfApp 
              ( _argIexpr) =
                  arg_ _argOisLhsOfApp 
          in  ( _lhsOexpr)))
sem_PatOutput_Escape :: Pos ->
                        Expr ->
                        T_PatOutput 
sem_PatOutput_Escape pos_ expr_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOexpr =
                  ({-# LINE 54 "RulesExpr.ag" #-}
                   expr_
                   {-# LINE 363 "RulesExpr.hs" #-}
                   )
          in  ( _lhsOexpr)))
sem_PatOutput_Field :: Ident ->
                       Ident ->
                       T_PatOutput 
sem_PatOutput_Field fld_ nm_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOexpr =
                  ({-# LINE 47 "RulesExpr.ag" #-}
                   Expr_Field fld_ nm_
                   {-# LINE 375 "RulesExpr.hs" #-}
                   )
          in  ( _lhsOexpr)))
sem_PatOutput_Prim :: Pos ->
                      PrimVal ->
                      T_PatOutput 
sem_PatOutput_Prim pos_ val_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOexpr =
                  ({-# LINE 49 "RulesExpr.ag" #-}
                   Expr_Prim pos_ val_
                   {-# LINE 387 "RulesExpr.hs" #-}
                   )
          in  ( _lhsOexpr)))
sem_PatOutput_Underscore :: Pos ->
                            T_PatOutput 
sem_PatOutput_Underscore pos_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _ident =
                  ({-# LINE 51 "RulesExpr.ag" #-}
                   Ident "__fresh" pos_
                   {-# LINE 398 "RulesExpr.hs" #-}
                   )
              _lhsOexpr =
                  ({-# LINE 52 "RulesExpr.ag" #-}
                   Expr_Seq [Stmt_Fresh pos_ [_ident    ]] (Expr_Var Mode_Ref _ident    )
                   {-# LINE 403 "RulesExpr.hs" #-}
                   )
          in  ( _lhsOexpr)))
sem_PatOutput_Var :: Ident ->
                     T_PatOutput 
sem_PatOutput_Var nm_  =
    (\ _lhsIisLhsOfApp ->
         (let _lhsOexpr :: Expr
              _lhsOexpr =
                  ({-# LINE 43 "RulesExpr.ag" #-}
                   if _lhsIisLhsOfApp
                   then Expr_Var Mode_Ref nm_
                   else Expr_Var Mode_Def nm_
                   {-# LINE 416 "RulesExpr.hs" #-}
                   )
          in  ( _lhsOexpr)))